# Auto-generated by mrtrix3/app.py:print_usage_pydra()

import typing
from pathlib import Path  # noqa: F401
from fileformats.generic import FsObject, File, Directory  # noqa: F401
from fileformats.medimage_mrtrix3 import Tracks, ImageIn, ImageOut  # noqa: F401
from pydra.utils.typing import MultiInputObj
from pydra.compose import shell


@shell.define
class DwiNormalise_Group(shell.Task["DwiNormalise_Group.Outputs"]):
    """

    References
    ----------

    Tournier, J.-D.; Smith, R. E.; Raffelt, D.; Tabbara, R.; Dhollander, T.; Pietsch, M.; Christiaens, D.; Jeurissen, B.; Yeh, C.-H. & Connelly, A. MRtrix3: A fast, flexible and open software framework for medical image processing and visualisation. NeuroImage, 2019, 202, 116137

    --------------



    **Author:** David Raffelt (david.raffelt@florey.edu.au)

    **Copyright:** Copyright (c) 2008-2024 the MRtrix3 contributors.

    This Source Code Form is subject to the terms of the Mozilla Public
    License, v. 2.0. If a copy of the MPL was not distributed with this
    file, You can obtain one at http://mozilla.org/MPL/2.0/.

    Covered Software is provided under this License on an "as is"
    basis, without warranty of any kind, either expressed, implied, or
    statutory, including, without limitation, warranties that the
    Covered Software is free of defects, merchantable, fit for a
    particular purpose or non-infringing.
    See the Mozilla Public License v. 2.0 for more details.

    For more details, see http://www.mrtrix.org/.

    """

    executable = ("dwinormalise", "group")

    input_dir: Directory = shell.arg(
        position=1,
        argstr="",
        help="The input directory containing all DWI images",
    )
    mask_dir: Directory = shell.arg(
        position=2,
        argstr="",
        help="Input directory containing brain masks, corresponding to one per input image (with the same file name prefix)",
    )
    nocleanup: bool = shell.arg(
        help="do not delete intermediate files during script execution, and do not delete scratch directory at script completion.",
        argstr="-nocleanup",
        default=False,
    )
    scratch: Directory | None = shell.arg(
        help="manually specify an existing directory in which to generate the scratch directory.",
        argstr="-scratch",
        default=None,
    )
    cont: typing.Any | None = shell.arg(
        help="continue the script from a previous execution; must provide the scratch directory path, and the name of the last successfully-generated file.",
        argstr="-cont",
        default=None,
    )
    info: bool = shell.arg(
        help="display information messages.",
        argstr="-info",
        default=False,
    )
    quiet: bool = shell.arg(
        help="do not display information messages or progress status. Alternatively, this can be achieved by setting the MRTRIX_QUIET environment variable to a non-empty string.",
        argstr="-quiet",
        default=False,
    )
    debug: bool = shell.arg(
        help="display debugging messages.",
        argstr="-debug",
        default=False,
    )
    force: bool = shell.arg(
        help="force overwrite of output files.",
        argstr="-force",
        default=False,
    )
    nthreads: int | None = shell.arg(
        help="use this number of threads in multi-threaded applications (set to 0 to disable multi-threading).",
        argstr="-nthreads",
        default=None,
    )
    config: MultiInputObj[MultiInputObj] = shell.arg(
        help="temporarily set the value of an MRtrix config file entry.",
        argstr="-config",
        default=None,
    )
    help: bool = shell.arg(
        help="display this information page and exit.",
        argstr="-help",
        default=False,
    )
    version: bool = shell.arg(
        help="display version information and exit.",
        argstr="-version",
        default=False,
    )
    fa_threshold: float | None = shell.arg(
        help="The threshold applied to the Fractional Anisotropy group template used to derive an approximate white matter mask (default: 0.4)",
        argstr="-fa_threshold",
        default=None,
    )

    class Outputs(shell.Outputs):
        output_dir: Directory = shell.outarg(
            position=3,
            argstr="",
            help="The output directory containing all of the intensity normalised DWI images",
            path_template="output_dir",
        )
        fa_template: ImageOut = shell.outarg(
            position=4,
            argstr="",
            help="The output population-specific FA template, which is thresholded to estimate a white matter mask",
            path_template="fa_template.mif",
        )
        wm_mask: ImageOut = shell.outarg(
            position=5,
            argstr="",
            help="The output white matter mask (in template space), used to estimate the median b=0 white matter value for normalisation",
            path_template="wm_mask.mif",
        )
